package mccity.heroes.skills.turret;

import net.minecraft.server.EntityArrow;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.block.Block;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;
import org.bukkit.util.BlockIterator;
import org.bukkit.util.Vector;

import java.lang.reflect.Field;
import java.util.Iterator;

public class Utils {

    public static void setArrowDamage(EntityArrow mcArrow, float damage) {
        try {
            Field damageField = mcArrow.getClass().getDeclaredField("damage");
            damageField.setAccessible(true);
            damageField.setDouble(mcArrow, damage);
        } catch (Exception ex) {
            SkillTurret.getLogger().info("SkillTurret reflection exception: " + ex.getMessage());
            ex.printStackTrace();
        }
    }

    public static void setArrowKnockback(EntityArrow mcArrow, int knockback) {
        try {
            Field knockbackField = mcArrow.getClass().getDeclaredField("n");
            knockbackField.setAccessible(true);
            knockbackField.setInt(mcArrow, knockback);
        } catch (Exception ex) {
            SkillTurret.getLogger().info("SkillTurret reflection exception: " + ex.getMessage());
            ex.printStackTrace();
        }
    }

    public static boolean inLineOfSight(Location pos1, Location pos2) {
        Vector direction = pos2.toVector().subtract(pos1.toVector());
        Iterator<Block> itr = new BlockIterator(pos1.getWorld(), pos1.toVector(), direction, 0, (int) direction.length());
        while (itr.hasNext()) {
            Block block = itr.next();
            int id = block.getTypeId();
            if (id != 0) {
                boolean solid = net.minecraft.server.Block.byId[id].material.isSolid();
                if (solid) return false;
            }
        }
        return true;
    }

    public static boolean tryConsumeItem(Inventory inv, Material mat) {
        int firstMatIndex = inv.first(mat);
        if (firstMatIndex != -1) {
            ItemStack targetStack = inv.getItem(firstMatIndex);
            if (targetStack.getAmount() == 1) {
                inv.setItem(firstMatIndex, null);
            } else {
                targetStack.setAmount(targetStack.getAmount() - 1);
            }
            return true;
        }
        return false;
    }
}
